from tkinter import *
import matplotlib
matplotlib.use("TkAgg")
from tkinter import messagebox

from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
from matplotlib.figure import Figure

#displays the second window
def secondScreen():
    global screen2
    screen2 = Tk()
    screen2.geometry("550x680")
    screen2.configure()
    screen2.title("FedUni Money Manager")
    labelHeader = Label(screen2, text="FedUni Money Manager", font=("Calibri", 28)).pack()

    global frame_top
    frame_top = Frame(screen2, width=500, height=200)
    frame_top.pack(fill=NONE, expand=False)
    # Label(text="").pack()

    global frame_bottom
    frame_bottom = Frame(screen2, width=500, height=500)

    frame_bottom.pack()

    global frame_below
    frame_below = Frame(screen2, width=500, height=500)
    frame_below.pack()

    #shows the all the widgets and graphs
    showBottomFrameWidgets()
    openAndshowgraph()
    showWidgets()

#calls openfile() and showGraph() to open the file and show the graph
def openAndshowgraph():
    openFile()
    global userno
    global balance
    global item1
    userno = data[0]
    pin = data[1]

    #this line gets the exact row of data for the balance
    balance = data[2]
    item1 = data[3]
    showGraph()

#opens the file
def openFile():
    filename="123456"
    file = open(filename+".txt", "r+")
    global data
    #puts all the line into the data list
    data = file.readlines()

#show the widgets in the topframe
def showWidgets():

    labelUserno = Label(frame_top, text="User No.: "+userno, font=("Calibri", 14))
    labelBalance = Label(frame_top, text="Balance: $"+balance, font=("Calibri", 14))

    labelUserno.grid(row=0,column=0)
    labelBalance.grid(row=0, column=1)

    buttonLogout = Button(frame_top, text="Logout", bg="#800000", fg="white", font=("Calibri", 11), command=logout)
    buttonLogout.grid(row=0, column=2, sticky="NE")

#destroys the window
def logout():
    screen2.destroy()

#show the graph using matplotlib library
def showGraph():
    x = []
    y = []

    for count,i in enumerate(data[3:]):
        #value of count is checked even or odd to append data to x and y lists so that all items go to x and prices for y
        if count%2==1:
            y.append(float(i))
        else:
            x.append(i)
    f = Figure(figsize=(4,4), dpi=100)
    f.suptitle("Expenses on Various Items")
    a=f.add_subplot(111)

    #a.set_xticklabels(y)
    for tick in a.xaxis.get_major_ticks():
        tick.label.set_fontsize(10)
        #sets the rotaion of the text in the bottom of the column
        tick.label.set_rotation(30)

    a.bar(x,y, ecolor="black", color="green")
    #a.hist(y, normed=True, bins=30)
    canvas = FigureCanvasTkAgg(f, frame_bottom)
    canvas.draw()

    canvas.get_tk_widget().grid(row=3, column=0, columnspan=6, rowspan=6,
               sticky=W+E+N+S, padx=5, pady=5)

#shows all the buttonframe widgets including the graph
def showBottomFrameWidgets():
    colorButton = "sky blue"
    labelAdditem = Label(frame_bottom, text="Add Item: ", font=("Calibri", 11))
    global entryAdditem
    entryAdditem = Entry(frame_bottom)
    labelAmount = Label(frame_bottom, text="Amount: ", font=("Calibri", 11))
    global entryAmount
    entryAmount = Entry(frame_bottom)

    buttonAdd = Button(frame_bottom, text="Add", bg=colorButton, font=("Calibri", 11), command=checkAmount)
    buttonShow = Button(frame_bottom, text="Refresh", bg=colorButton, font=("Calibri", 11), command=refreshWindow)

    labelAdditem.grid(row=0, column=0)
    entryAdditem.grid(row=0, column=1)
    labelAmount.grid(row=0, column=2)
    entryAmount.grid(row=0, column=3)

    buttonAdd.grid(row=0, column=4)
    buttonShow.grid(row=0, column=5)


    labelAddbalance = Label(frame_bottom, text="Add Balance: ", font=("Calibri", 11))
    global entryAddbalance
    entryAddbalance = Entry(frame_bottom)

    buttonAddbalance = Button(frame_bottom, text="Add Balance", bg=colorButton, font=("Calibri", 11), command=addBalance)

    labelAddbalance.grid(row=2, column=1)
    entryAddbalance.grid(row=2, column=2)
    buttonAddbalance.grid(row=2, column=3)

#edits the balance line of the code in the file to update with a new balance
def addBalance():
    openFile()
    filename = "123456"
    file = open(filename + ".txt", "r")
    getBalance = entryAddbalance.get()
    global data
    data = file.readlines()

    newbalance = float(data[2]) + float(getBalance)
    data[2] = str(newbalance) + "\n"
    file = open(filename + ".txt", "w")
    file.writelines(data)
    messagebox.showinfo("Balance", "Balance added successfully!")

#writes item name and amount to the file
def writeToFile():
    item = entryAdditem.get()
    amount = entryAmount.get()
    filename = "123456"
    file = open(filename+".txt", "a")
    file.write("\n"+item+"\n"+amount)
    messagebox.showinfo("Adding expenses", "Added successfully!")
    #the function decreases the amount as the amount is spent on the item
    decreaseAmount()
    #calls the function to reload the window after the item is added
    refreshWindow()

#refreshes the window to reload the balance and items in the graph
def refreshWindow():
    screen2.destroy()
    secondScreen()

#decreases the balance amount in the file, keeping everything else same
def decreaseAmount():
    itemprice = float(entryAmount.get())
    filename = "123456"
    file = open(filename + ".txt", "r")
    global data
    data = file.readlines()
    newbalance=float(data[2])-itemprice
    data[2]=str(newbalance)+"\n"
    file = open(filename + ".txt", "w")
    file.writelines(data)

#before adding the items and their prices, checks whether the expense exceeds the balance
def checkAmount():
    openFile()
    itemprice = float(entryAmount.get())
    if(float(data[2])<itemprice):
        messagebox.showwarning("Insufficient balance", "Can't spend that much!\nPlease, check your balance.")
    else:
        #if the price entered is less than the balance, calls the function to write to the file
        writeToFile()